<?php

/**
 * The file that defines the core plugin class
 *
 * A class definition that includes attributes and functions used across both the
 * public-facing side of the site and the admin area.
 *
 * @link       https://revivedesignstudios.com
 * @since      1.0.0
 *
 * @package    Rds_Bt50_Scorecard
 * @subpackage Rds_Bt50_Scorecard/includes
 */

/**
 * The core plugin class.
 *
 * This is used to define internationalization, admin-specific hooks, and
 * public-facing site hooks.
 *
 * Also maintains the unique identifier of this plugin as well as the current
 * version of the plugin.
 *
 * @since      1.0.0
 * @package    Rds_Bt50_Scorecard
 * @subpackage Rds_Bt50_Scorecard/includes
 * @author     Revive Design Studios <connect@revivedesignstudios.com>
 */
class Rds_Bt50_Scorecard {

	/**
	 * The loader that's responsible for maintaining and registering all hooks that power
	 * the plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      Rds_Bt50_Scorecard_Loader    $loader    Maintains and registers all hooks for the plugin.
	 */
	protected $loader;

	/**
	 * The unique identifier of this plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $plugin_name    The string used to uniquely identify this plugin.
	 */
	protected $plugin_name;

	/**
	 * The current version of the plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $version    The current version of the plugin.
	 */
	protected $version;

	/**
	 * The instance for accessing bt50, openstates, and geocode data.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private $apiInstance;

	/**
	 * Define the core functionality of the plugin.
	 *
	 * Set the plugin name and the plugin version that can be used throughout the plugin.
	 * Load the dependencies, define the locale, and set the hooks for the admin area and
	 * the public-facing side of the site.
	 *
	 * @since    1.0.0
	 */
	public function __construct() {
		if ( defined( 'RDS_BT50_SCORECARD_VERSION' ) ) {
			$this->version = RDS_BT50_SCORECARD_VERSION;
		} else {
			$this->version = '1.0.0';
		}
		$this->plugin_name = 'rds-bt50-scorecard';

		$this->load_dependencies();
		$this->set_locale();
		$this->initialize_api_instance();
		$this->define_admin_hooks();
		$this->define_public_hooks();
		$this->define_api_hooks();
	}

	/**
	 * Load the required dependencies for this plugin.
	 *
	 * Include the following files that make up the plugin:
	 *
	 * - Rds_Bt50_Scorecard_Loader. Orchestrates the hooks of the plugin.
	 * - Rds_Bt50_Scorecard_i18n. Defines internationalization functionality.
	 * - Rds_Bt50_Scorecard_Admin. Defines all hooks for the admin area.
	 * - Rds_Bt50_Scorecard_Public. Defines all hooks for the public side of the site.
	 *
	 * Create an instance of the loader which will be used to register the hooks
	 * with WordPress.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function load_dependencies() {

		/**
		 * The class responsible for orchestrating the actions and filters of the
		 * core plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-rds-bt50-scorecard-loader.php';

		/**
		 * The class responsible for defining internationalization functionality
		 * of the plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-rds-bt50-scorecard-i18n.php';

		/**
		 * The class responsible for defining all actions that occur in the admin area.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'admin/class-rds-bt50-scorecard-admin.php';

		/**
		 * The class responsible for defining all actions that occur in the public-facing
		 * side of the site.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'public/class-rds-bt50-scorecard-public.php';

		$this->loader = new Rds_Bt50_Scorecard_Loader();

		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-rds-bt50-scorecard-api.php';
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-rds-bt50-api.php';
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-rds-bt50-openstates-api.php';
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-rds-bt50-data-client.php';
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-rds-bt50-score-blender.php';
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-rds-bt50-scorecard-validations.php';
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-rds-bt50-dictionary-generator.php';
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'vendor/autoload.php';
	}

	/**
	 * Define the locale for this plugin for internationalization.
	 *
	 * Uses the Rds_Bt50_Scorecard_i18n class in order to set the domain and to register the hook
	 * with WordPress.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function set_locale() {
		$plugin_i18n = new Rds_Bt50_Scorecard_i18n();
		$this->loader->add_action( 'plugins_loaded', $plugin_i18n, 'load_plugin_textdomain' );
	}

	/**
	 * Register all of the hooks related to the admin area functionality
	 * of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_admin_hooks() {
		$plugin_admin = new Rds_Bt50_Scorecard_Admin( $this->get_plugin_name(), $this->get_version(), $this->apiInstance );

		$this->loader->add_action( 'admin_enqueue_scripts', $plugin_admin, 'enqueue_styles' );
		$this->loader->add_action( 'admin_enqueue_scripts', $plugin_admin, 'enqueue_scripts' );

		// Add menu item
		$this->loader->add_action( 'admin_menu', $plugin_admin, 'add_plugin_admin_menu' );

		// Save/Update our plugin options
		// $this->loader->add_action('admin_init', $plugin_admin, 'options_update');

		// Display any admin notices
		$this->loader->add_action('admin_init', $plugin_admin, 'display_alerts');

		// Add Settings link to the plugin
		$plugin_basename = plugin_basename( plugin_dir_path( __DIR__ ) . $this->plugin_name . '.php' );
		$this->loader->add_filter( 'plugin_action_links_' . $plugin_basename, $plugin_admin, 'add_action_links' );
	}

	/**
	 * Register all of the hooks related to the public-facing functionality
	 * of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_public_hooks() {
		$plugin_public = new Rds_Bt50_Scorecard_Public( $this->get_plugin_name(), $this->get_version() );
		$this->loader->add_action( 'wp_enqueue_scripts', $plugin_public, 'register_scorecard_app');
		add_shortcode('bt50-scorecard', array($plugin_public, 'register_scorecard_shortcode'));
	}

	/**
	 * Register all of the hooks related to the rest api of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_api_hooks() {
		$plugin_api = new Rds_Bt50_Scorecard_Api( $this->get_plugin_name(), $this->get_version(), $this->apiInstance );
		// Add REST API endpoints
		$this->loader->add_action( 'rest_api_init', $plugin_api, 'register_rest_routes' );
	}

	/**
	 * Initialize the api clients
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function initialize_api_instance() {
		$bt50ApiKey = get_option( 'score_bt50_api_key' );
		$openStatesApiKey = '4236eea4-4087-4b3b-bc48-d58b41ac3240';
		$bt50Client = new Bt50ApiClient($bt50ApiKey);
		$openstatesClient = new OpenStatesApiClient($openStatesApiKey);
		$this->apiInstance = new Bt50DataClient($bt50Client, $openstatesClient);
	}

	/**
	 * Run the loader to execute all of the hooks with WordPress.
	 *
	 * @since    1.0.0
	 */
	public function run() {
		$this->loader->run();
	}

	/**
	 * The name of the plugin used to uniquely identify it within the context of
	 * WordPress and to define internationalization functionality.
	 *
	 * @since     1.0.0
	 * @return    string    The name of the plugin.
	 */
	public function get_plugin_name() {
		return $this->plugin_name;
	}

	/**
	 * The reference to the class that orchestrates the hooks with the plugin.
	 *
	 * @since     1.0.0
	 * @return    Rds_Bt50_Scorecard_Loader    Orchestrates the hooks of the plugin.
	 */
	public function get_loader() {
		return $this->loader;
	}

	/**
	 * Retrieve the version number of the plugin.
	 *
	 * @since     1.0.0
	 * @return    string    The version number of the plugin.
	 */
	public function get_version() {
		return $this->version;
	}

}
